Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutDialog.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutDialog.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutDialog.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutDialog.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutDialog.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutDialog.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/AboutView.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/HeuristicLab.Clients.Hive.Slave.Views-3.3.csproj
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/HeuristicLab.Clients.Hive.Slave.Views-3.3.csproj	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/HeuristicLab.Clients.Hive.Slave.Views-3.3.csproj	(revision 16662)
@@ -11,5 +11,5 @@
     <RootNamespace>HeuristicLab.Clients.Hive.SlaveCore.Views</RootNamespace>
     <AssemblyName>HeuristicLab.Clients.Hive.Slave.Views-3.3</AssemblyName>
-    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <TargetFrameworkProfile />
@@ -89,8 +89,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <HintPath>..\..\bin\HeuristicLab.Collections-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
     <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>..\..\bin\HeuristicLab.Common-3.3.dll</HintPath>
@@ -109,12 +105,4 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Data-3.3">
-      <HintPath>..\..\bin\HeuristicLab.Data-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Data.Views-3.3">
-      <HintPath>..\..\bin\HeuristicLab.Data.Views-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
     <Reference Include="HeuristicLab.MainForm-3.3">
       <HintPath>..\..\bin\HeuristicLab.MainForm-3.3.dll</HintPath>
@@ -123,16 +111,4 @@
     <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3">
       <HintPath>..\..\bin\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Optimization-3.3">
-      <HintPath>..\..\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Optimizer-3.3">
-      <HintPath>..\..\bin\HeuristicLab.Optimizer-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Persistence-3.3">
-      <HintPath>..\..\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/Plugin.cs.frame
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/Plugin.cs.frame	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/Plugin.cs.frame	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -30,16 +30,10 @@
   [PluginFile("HeuristicLab.Clients.Hive.Slave.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Clients.Hive.SlaveCore", "3.3")]
-  [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Data.Views", "3.3")]
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3")]
-  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabClientsHiveSlaveViewsPlugin : PluginBase {
   }
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsBase.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsBase.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsBase.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsBase.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsBase.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsBase.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveItem.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveItem.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveItem.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainView.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainView.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainView.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainView.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainView.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainView.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewTray.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewTray.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewTray.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewTray.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewTray.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewTray.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveView.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveView.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveView.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveView.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveView.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveView.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/TaskView.Designer.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/TaskView.Designer.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/TaskView.Designer.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/TaskView.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/TaskView.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave.Views/3.3/TaskView.cs	(revision 16662)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.