Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/HeuristicLab.Problems.DynamicalSystemsModelling-3.3.csproj
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/HeuristicLab.Problems.DynamicalSystemsModelling-3.3.csproj	(revision 16662)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/HeuristicLab.Problems.DynamicalSystemsModelling-3.3.csproj	(revision 16663)
@@ -11,5 +11,5 @@
     <RootNamespace>HeuristicLab.Problems.DynamicalSystemsModelling</RootNamespace>
     <AssemblyName>HeuristicLab.Problems.DynamicalSystemsModelling-3.3</AssemblyName>
-    <TargetFrameworkVersion>v4.6</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
     <TargetFrameworkProfile>
     </TargetFrameworkProfile>
@@ -104,4 +104,8 @@
       <HintPath>..\..\bin\ALGLIB-3.7.0.dll</HintPath>
     </Reference>
+    <Reference Include="HEAL.Attic, Version=1.0.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\bin\HEAL.Attic.dll</HintPath>
+    </Reference>
     <Reference Include="Microsoft.CSharp" />
     <Reference Include="System" />
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/OdeParameterIdentification.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/OdeParameterIdentification.cs	(revision 16662)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/OdeParameterIdentification.cs	(revision 16663)
@@ -34,9 +34,10 @@
 using HeuristicLab.Random;
 using System.Collections.Generic;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DynamicalSystemsModelling {
   [Item("OdeParameterIdentification", "TODO")]
   [Creatable(CreatableAttribute.Categories.DataAnalysisRegression, Priority = 120)]
-  [StorableClass]
+  [StorableType("93C151A2-9579-4013-9E67-7611F9378962")]
   public sealed class OdeParameterIdentification : FixedDataAnalysisAlgorithm<Problem> {
     private const string RegressionSolutionResultName = "Regression solution";
@@ -102,5 +103,5 @@
 
     [StorableConstructor]
-    private OdeParameterIdentification(bool deserializing) : base(deserializing) { }
+    private OdeParameterIdentification(StorableConstructorFlag _) : base(_) { }
     private OdeParameterIdentification(OdeParameterIdentification original, Cloner cloner)
       : base(original, cloner) {
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Plugin.cs.frame
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Plugin.cs.frame	(revision 16662)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Plugin.cs.frame	(revision 16663)
@@ -29,4 +29,5 @@
   [Plugin("HeuristicLab.Problems.DynamicalSystemsModelling","TODO", "3.3.0.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.DynamicalSystemsModelling-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Attic", "1.0")]
   [PluginDependency("HeuristicLab.ALGLIB", "3.7")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Problem.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Problem.cs	(revision 16662)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Problem.cs	(revision 16663)
@@ -38,9 +38,10 @@
 using HeuristicLab.Problems.Instances;
 using Variable = HeuristicLab.Problems.DataAnalysis.Symbolic.Variable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DynamicalSystemsModelling {
   [Item("Dynamical Systems Modelling Problem", "TODO")]
   [Creatable(CreatableAttribute.Categories.GeneticProgrammingProblems, Priority = 900)]
-  [StorableClass]
+  [StorableType("065C6A61-773A-42C9-9DE5-61A5D1D823EB")]
   public sealed class Problem : SingleObjectiveBasicProblem<MultiEncoding>, IRegressionProblem, IProblemInstanceConsumer<IRegressionProblemData>, IProblemInstanceExporter<IRegressionProblemData> {
     #region parameter names
@@ -147,5 +148,5 @@
     // persistence
     [StorableConstructor]
-    private Problem(bool deserializing) : base(deserializing) { }
+    private Problem(StorableConstructorFlag _) : base(_) { }
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Solution.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Solution.cs	(revision 16662)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Solution.cs	(revision 16663)
@@ -10,7 +10,8 @@
 using HeuristicLab.Problems.DataAnalysis.Symbolic;
 using HeuristicLab.Random;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DynamicalSystemsModelling {
-  [StorableClass]
+  [StorableType("70AA254D-706E-474A-8129-E9A8A7067FE1")]
   public class Solution : Item {
     [Storable]
@@ -48,5 +49,5 @@
 
     [StorableConstructor]
-    private Solution(bool deserializing) : base(deserializing) { }
+    private Solution(StorableConstructorFlag _) : base(_) { }
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {